diff --git a/oflog/libsrc/queue.cc b/oflog/libsrc/queue.cc
new file mode 100644
index 0000000..976432c
--- /dev/null
+++ b/oflog/libsrc/queue.cc
@@ -0,0 +1,191 @@
+//  Copyright (C) 2009-2010, Vaclav Haisman. All rights reserved.
+//  
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//  
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//  
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//  
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+#include "dcmtk/oflog/config.h"
+#ifndef DCMTK_LOG4CPLUS_SINGLE_THREADED
+
+#include "dcmtk/oflog/helpers/queue.h"
+#include "dcmtk/oflog/helpers/loglog.h"
+#include "dcmtk/oflog/thread/syncpub.h"
+#include <stdexcept>
+#include <algorithm>
+#include <iterator>
+
+
+namespace dcmtk {
+namespace log4cplus { namespace thread {
+
+
+Queue::Queue (unsigned len)
+    : queue()
+    , mutex (Mutex::DEFAULT)
+    , ev_consumer (false)
+    , sem (len, len) 
+    , flags (DRAIN)
+{ }
+
+
+Queue::~Queue ()
+{ }
+
+
+Queue::flags_type
+Queue::put_event (spi::InternalLoggingEvent const & ev)
+{
+    flags_type ret_flags = ERROR_BIT;
+    try
+    {
+        ev.gatherThreadSpecificData ();
+        
+        SemaphoreGuard semguard (sem);
+        MutexGuard mguard (mutex);
+
+        ret_flags |= flags;
+        
+        if (flags & EXIT)
+        {
+            ret_flags &= ~(ERROR_BIT | ERROR_AFTER);
+            return ret_flags;
+        }
+        else
+        {
+            queue.push_back (ev);
+            ret_flags |= ERROR_AFTER;
+            semguard.detach ();
+            flags |= QUEUE;
+            ret_flags |= flags;
+            mguard.unlock ();
+            mguard.detach ();
+            ev_consumer.signal ();
+        }
+    }
+    catch (STD_NAMESPACE runtime_error const & e)
+    {
+        (void)e;
+        return ret_flags;
+    }
+
+    ret_flags &= ~(ERROR_BIT | ERROR_AFTER);
+    return ret_flags;
+}
+
+
+Queue::flags_type
+Queue::signal_exit (bool drain)
+{
+    flags_type ret_flags = 0;
+
+    try
+    {
+        MutexGuard mguard (mutex);
+
+        ret_flags |= flags;
+
+        if (! (flags & EXIT))
+        {
+            if (drain)
+                flags |= DRAIN;
+            else
+                flags &= ~DRAIN;
+            flags |= EXIT;
+            ret_flags = flags;
+            mguard.unlock ();
+            mguard.detach ();
+            ev_consumer.signal ();
+        }
+    }
+    catch (STD_NAMESPACE runtime_error const & e)
+    {
+        (void)e;
+        ret_flags |= ERROR_BIT;
+        return ret_flags;
+    }
+
+    return ret_flags;
+}
+
+
+Queue::flags_type
+Queue::get_events (queue_storage_type * buf)
+{
+    flags_type ret_flags = 0;
+
+    try
+    {
+        while (true)
+        {
+            MutexGuard mguard (mutex);
+
+            ret_flags = flags;
+
+            if (((QUEUE & flags) && ! (EXIT & flags))
+                || ((EXIT | DRAIN | QUEUE) & flags) == (EXIT | DRAIN | QUEUE))
+            {
+                assert (! queue.empty ());
+
+                size_t const cnt = queue.size ();
+                queue.swap (*buf);
+                queue.clear ();
+                flags &= ~QUEUE;
+                for (size_t i = 0; i != cnt; ++i)
+                    sem.unlock ();
+
+                ret_flags = flags | EVENT;
+                break;
+            }
+            else if (((EXIT | QUEUE) & flags) == (EXIT | QUEUE))
+            {
+                assert (! queue.empty ());
+                queue.clear ();
+                flags &= ~QUEUE;
+                ev_consumer.reset ();
+                sem.unlock ();
+                ret_flags = flags;
+                break;
+            }
+            else if (EXIT & flags)
+                break;
+            else
+            {
+                ev_consumer.reset ();
+                mguard.unlock ();
+                mguard.detach ();
+                ev_consumer.wait ();
+            }
+        }
+    }
+    catch (STD_NAMESPACE runtime_error const & e)
+    {
+        (void)e;
+        ret_flags |= ERROR_BIT;
+    }
+
+    return ret_flags;
+}
+
+
+} } // namespace log4cplus { namespace thread {
+} // end namespace dcmtk
+
+
+#endif // DCMTK_LOG4CPLUS_SINGLE_THREADED
diff --git a/oflog/libsrc/rootlog.cc b/oflog/libsrc/rootlog.cc
index 72650a5..bd92e60 100644
--- a/oflog/libsrc/rootlog.cc
+++ b/oflog/libsrc/rootlog.cc
@@ -4,7 +4,7 @@
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2003-2009 Tad E. Smith
+// Copyright 2003-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -19,21 +19,22 @@
 // limitations under the License.
 
 #include "dcmtk/oflog/spi/rootlog.h"
+#include "dcmtk/oflog/helpers/loglog.h"
+#include "dcmtk/oflog/thread/syncpub.h"
 
-using namespace dcmtk::log4cplus;
-using namespace dcmtk::log4cplus::helpers;
-using namespace dcmtk::log4cplus::spi;
 
+namespace dcmtk {
+namespace log4cplus { namespace spi {
 
 
 //////////////////////////////////////////////////////////////////////////////
 // RootLogger Constructor
 //////////////////////////////////////////////////////////////////////////////
 
-RootLogger::RootLogger(Hierarchy& h, LogLevel ll_)
+RootLogger::RootLogger(Hierarchy& h, LogLevel loglevel)
 : LoggerImpl(DCMTK_LOG4CPLUS_TEXT("root"), h)
 {
-    setLogLevel(ll_);
+    setLogLevel(loglevel);
 }
 
 
@@ -42,21 +43,25 @@ RootLogger::RootLogger(Hierarchy& h, LogLevel ll_)
 // Logger Methods
 //////////////////////////////////////////////////////////////////////////////
 
-LogLevel
+LogLevel 
 RootLogger::getChainedLogLevel() const
 {
     return ll;
 }
 
 
-void
-RootLogger::setLogLevel(LogLevel ll_)
+void 
+RootLogger::setLogLevel(LogLevel loglevel)
 {
-    if(ll_ == NOT_SET_LOG_LEVEL) {
-        getLogLog().error(DCMTK_LOG4CPLUS_TEXT("You have tried to set NOT_SET_LOG_LEVEL to root."));
+    if(loglevel == NOT_SET_LOG_LEVEL) {
+        helpers::getLogLog().error(
+            DCMTK_LOG4CPLUS_TEXT("You have tried to set NOT_SET_LOG_LEVEL to root."));
     }
     else {
-        LoggerImpl::setLogLevel(ll_);
+        LoggerImpl::setLogLevel(loglevel);
     }
 }
 
+
+} } // namespace log4cplus { namespace spi {
+} // end namespace dcmtk
diff --git a/oflog/libsrc/sleep.cc b/oflog/libsrc/sleep.cc
index 28e77fb..a9b17e5 100644
--- a/oflog/libsrc/sleep.cc
+++ b/oflog/libsrc/sleep.cc
@@ -4,7 +4,7 @@
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2003-2009 Tad E. Smith
+// Copyright 2003-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -18,19 +18,95 @@
 // See the License for the specific language governing permissions and
 // limitations under the License.
 
+#include "dcmtk/oflog/config/windowsh.h"
 #include "dcmtk/oflog/helpers/sleep.h"
+#include "dcmtk/oflog/helpers/timehelp.h"
 
-#include "dcmtk/ofstd/ofstd.h"
+#include <cerrno>
+#if defined (DCMTK_LOG4CPLUS_HAVE_ERRNO_H)
+#include <errno.h>
+#endif
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_TIME_H)
+#include <time.h>
+#endif
+
+
+namespace dcmtk {
+namespace log4cplus { namespace helpers {
 
 
 ///////////////////////////////////////////////////////////////////////////////
 // public methods
 ///////////////////////////////////////////////////////////////////////////////
 
+int const MILLIS_TO_NANOS = 1000000;
+int const SEC_TO_MILLIS = 1000;
+
+
+#if ! defined (_WIN32)
+static inline
+int
+unix_nanosleep (const struct timespec *req, struct timespec *rem)
+{
+#if defined (DCMTK_LOG4CPLUS_HAVE_CLOCK_NANOSLEEP)
+    return clock_nanosleep (CLOCK_REALTIME, 0, req, rem);
+
+#elif defined (DCMTK_LOG4CPLUS_HAVE_NANOSLEEP)
+    return nanosleep (req, rem);
+
+#else
+#  error no nanosleep() or clock_nanosleep()
+#endif
+}
+
+#endif
+
+
 void
-dcmtk::log4cplus::helpers::sleep(unsigned long secs)
+sleep(unsigned long secs, unsigned long nanosecs)
 {
-    while (secs > 0) {
-        secs = OFStandard::sleep(secs);
+#if defined(_WIN32)
+    DWORD const MAX_SLEEP_SECONDS = 4294966;        // (2**32-2)/1000
+
+    DWORD nano_millis = nanosecs / OFstatic_cast(unsigned long, MILLIS_TO_NANOS);
+    if (secs <= MAX_SLEEP_SECONDS) {
+        Sleep((secs * SEC_TO_MILLIS) + nano_millis);
+        return;
+    }
+        
+    DWORD no_of_max_sleeps = secs / MAX_SLEEP_SECONDS;
+            
+    for(DWORD i = 0; i < no_of_max_sleeps; i++) {
+        Sleep(MAX_SLEEP_SECONDS * SEC_TO_MILLIS);
     }
+               
+    Sleep((secs % MAX_SLEEP_SECONDS) * SEC_TO_MILLIS + nano_millis);
+#else
+    timespec sleep_time = { OFstatic_cast(STD_NAMESPACE time_t, secs),
+                            OFstatic_cast(long, nanosecs) };
+    timespec remain;
+    while (unix_nanosleep (&sleep_time, &remain)) {
+        if (errno == EINTR) {
+            sleep_time.tv_sec  = remain.tv_sec;
+            sleep_time.tv_nsec = remain.tv_nsec;               
+            continue;
+        }
+        else {
+            return;
+        }
+    }
+#endif
+}
+
+
+void
+sleepmillis(unsigned long millis)
+{
+    unsigned long secs = millis / SEC_TO_MILLIS;
+    unsigned long nanosecs = (millis % SEC_TO_MILLIS) * MILLIS_TO_NANOS;
+    sleep(secs, nanosecs);
 }
+
+} } // namespace log4cplus { namespace helpers {
+} // end namespace dcmtk
diff --git a/oflog/libsrc/snprintf.cc b/oflog/libsrc/snprintf.cc
new file mode 100644
index 0000000..bbf59cb
--- /dev/null
+++ b/oflog/libsrc/snprintf.cc
@@ -0,0 +1,244 @@
+//  Copyright (C) 2010, Vaclav Haisman. All rights reserved.
+//  
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//  
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//  
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//  
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+#include "dcmtk/oflog/helpers/snprintf.h"
+#include "dcmtk/oflog/helpers/loglog.h"
+#include "dcmtk/oflog/internal/internal.h"
+#include <cstdarg>
+#include <cstdio>
+#if defined (UNICODE)
+#include <cwchar>
+#endif
+#if defined (DCMTK_LOG4CPLUS_HAVE_STDARG_H)
+#  include <stdarg.h>
+#endif
+#if defined (DCMTK_LOG4CPLUS_HAVE_WCHAR_H)
+#  include <wchar.h>
+#endif
+#if defined (DCMTK_LOG4CPLUS_HAVE_STDIO_H)
+#  include <stdio.h>
+#endif
+
+
+namespace dcmtk {
+namespace log4cplus { namespace helpers {
+
+
+size_t const START_BUF_SIZE = 512;
+
+#if defined (_WIN32)
+char const NULL_FILE[] = "NUL";
+#else
+char const NULL_FILE[] = "/dev/null";
+#endif
+
+
+namespace
+{
+
+
+#if defined (DCMTK_LOG4CPLUS_USE_POOR_MANS_SNPRINTF)
+
+static inline int vftprintf (STD_NAMESPACE FILE * file, tchar const * fmt,
+    va_list args) DCMTK_LOG4CPLUS_FORMAT_ATTRIBUTE (__printf__, 2, 0);
+
+static inline
+int
+vftprintf (STD_NAMESPACE FILE * file, tchar const * fmt, va_list args)
+{
+#if defined (UNICODE)
+#  if defined (DCMTK_LOG4CPLUS_HAVE_VFWPRINTF_S)
+    return vfwprintf_s (file, fmt, args);
+#  else
+    return STD_NAMESPACE vfwprintf (file, fmt, args);
+#  endif
+#else
+#  if defined (DCMTK_LOG4CPLUS_HAVE_VFPRINTF_S)
+    return vfprintf_s (file, fmt, args);
+#  else
+    return STD_NAMESPACE vfprintf (file, fmt, args);
+#  endif
+#endif
+}
+
+
+static inline int vstprintf (tchar * dest, size_t dest_size,
+    tchar const * fmt, va_list args)
+    DCMTK_LOG4CPLUS_FORMAT_ATTRIBUTE (__printf__, 3, 0);
+
+static inline
+int
+vstprintf (tchar * dest, size_t dest_size, tchar const * fmt,
+    va_list args)
+{
+    int ret;
+#if defined (UNICODE)
+#  if defined (DCMTK_LOG4CPLUS_HAVE_VSWPRINTF_S)
+    ret = vswprintf_s (dest, dest_size, fmt, args);
+#  else
+    ret = STD_NAMESPACE vswprintf (dest, dest_size, fmt, args);
+#  endif
+#else
+#  if defined (DCMTK_LOG4CPLUS_HAVE_VSPRINTF_S)
+    ret = vsprintf_s (dest, dest_size, fmt, args);
+#  else
+    ret = STD_NAMESPACE vsprintf (dest, fmt, args);
+#  endif
+#endif
+
+    if (ret >= 0)
+        assert (OFstatic_cast(size_t, ret) <= dest_size);
+    
+    return ret;
+}
+
+#else /* ?defined (DCMTK_LOG4CPLUS_USE_POOR_MANS_SNPRINTF) */
+
+static inline int vsntprintf (tchar * dest, size_t dest_size,
+    tchar const * fmt, va_list args)
+    DCMTK_LOG4CPLUS_FORMAT_ATTRIBUTE (__printf__, 3, 0);
+
+static inline
+int
+vsntprintf (tchar * dest, size_t dest_size, tchar const * fmt,
+    va_list args)
+{
+    int ret;
+
+#if defined (UNICODE)
+#  if defined (DCMTK_LOG4CPLUS_HAVE__VSNWPRINTF_S) && defined (_TRUNCATE)
+    ret = _vsnwprintf_s (dest, dest_size, _TRUNCATE, fmt, args);
+#  else
+    ret = STD_NAMESPACE vswprintf (dest, dest_size, fmt, args);
+#  endif
+#else
+#  if defined (DCMTK_LOG4CPLUS_HAVE_VSNPRINTF_S) && defined (_TRUNCATE)
+    ret = vsnprintf_s (dest, dest_size, _TRUNCATE, fmt, args);
+#  elif defined (DCMTK_LOG4CPLUS_HAVE__VSNPRINTF_S) && defined (_TRUNCATE)
+    ret = _vsnprintf_s (dest, dest_size, _TRUNCATE, fmt, args);
+#  elif defined (DCMTK_LOG4CPLUS_HAVE_VSNPRINTF)
+    ret = vsnprintf (dest, dest_size, fmt, args);
+#  elif defined (DCMTK_LOG4CPLUS_HAVE__VSNPRINTF)
+    ret = _vsnprintf (dest, dest_size, fmt, args);
+#  else
+#    error "None of vsnprintf_s, _vsnprintf_s, vsnprintf or _vsnprintf is available."
+#  endif
+#endif
+    
+    return ret;
+}
+#endif
+
+
+}
+
+
+snprintf_buf::snprintf_buf ()
+    : buf (START_BUF_SIZE)
+{ }
+
+
+tchar const *
+snprintf_buf::print (tchar const * fmt, ...)
+{
+    assert (fmt);
+
+    va_list args;
+    va_start (args, fmt);
+    tchar const * ret = print_va_list (fmt, args);
+    va_end (args);
+    return ret;
+}
+
+
+tchar const *
+snprintf_buf::print_va_list(tchar const * fmt, va_list args)
+{
+    int printed;
+    size_t const fmt_len = STD_NAMESPACE char_traits<tchar>::length (fmt);
+    size_t buf_size = buf.size ();
+    size_t const output_estimate = fmt_len + fmt_len / 2 + 1;
+    if (output_estimate > buf_size)
+        buf.resize (output_estimate);
+
+#if defined (DCMTK_LOG4CPLUS_USE_POOR_MANS_SNPRINTF)
+    STD_NAMESPACE FILE * & fnull = internal::get_ptd ()->fnull;
+    if (! fnull)
+    {
+        fnull = STD_NAMESPACE fopen (NULL_FILE, "wb");
+        if (! fnull)
+        {
+            LogLog::getLogLog ()->error (
+                DCMTK_LOG4CPLUS_TEXT ("Could not open NULL_FILE."));
+            buf.clear ();
+            buf.push_back (0);
+            return &buf[0];
+        }
+    }
+   
+    printed = vftprintf (fnull, fmt, args);
+    if (printed == -1)
+    {
+        LogLog::getLogLog ()->error (
+            DCMTK_LOG4CPLUS_TEXT ("Error printing into NULL_FILE."));
+        buf.clear ();
+        buf.push_back (0);
+        return &buf[0];
+    }
+
+    buf.resize (printed + 1);
+    int sprinted = vstprintf (&buf[0], buf.size (), fmt, args);
+    if (sprinted == -1)
+    {
+        LogLog::getLogLog ()->error (
+            DCMTK_LOG4CPLUS_TEXT ("Error printing into string."));
+        buf.clear ();
+        buf.push_back (0);
+        return &buf[0];
+    }
+    assert (printed == sprinted);
+    
+    buf[sprinted] = 0;
+
+#else
+    do
+    {
+        printed = vsntprintf (&buf[0], buf_size - 1, fmt, args);
+        if (printed == -1)
+        {
+            buf_size *= 2;
+            buf.resize (buf_size);
+        }
+        else
+            buf[printed] = 0;
+    }
+    while (printed == -1);
+
+#endif
+
+    return &buf[0];
+}
+
+
+} } // namespace log4cplus { namespace helpers
+} // end namespace dcmtk
diff --git a/oflog/libsrc/sockbuff.cc b/oflog/libsrc/sockbuff.cc
index 034e191..2f799e1 100644
--- a/oflog/libsrc/sockbuff.cc
+++ b/oflog/libsrc/sockbuff.cc
@@ -4,7 +4,7 @@
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2003-2009 Tad E. Smith
+// Copyright 2003-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -18,28 +18,24 @@
 // See the License for the specific language governing permissions and
 // limitations under the License.
 
+#include <cstring>
+#include <limits>
 #include "dcmtk/oflog/helpers/sockbuff.h"
 #include "dcmtk/oflog/helpers/loglog.h"
-//#include <cstring>
-#define INCLUDE_CSTRING
-//#include <limits>
-#define INCLUDE_CLIMITS
-#include "dcmtk/ofstd/ofstdinc.h"
 
 #if !defined(_WIN32)
-#  ifdef HAVE_NETDB_H
-#    include <netdb.h>
-#  endif
+#  include <netdb.h>
 #else
-#include <winsock.h>
+#  include "dcmtk/oflog/config/windowsh.h"
 #endif
 
-#if defined (__CYGWIN__) || defined (DCMTK_LOG4CPLUS_HAVE_NETINET_IN_H)
+#if defined (DCMTK_LOG4CPLUS_HAVE_NETINET_IN_H)
 #include <netinet/in.h>
 #endif
 
-using namespace dcmtk::log4cplus;
-using namespace dcmtk::log4cplus::helpers;
+
+namespace dcmtk {
+namespace log4cplus { namespace helpers {
 
 
 //////////////////////////////////////////////////////////////////////////////
@@ -50,58 +46,17 @@ SocketBuffer::SocketBuffer(size_t maxsize_)
 : maxsize(maxsize_),
   size(0),
   pos(0),
-  buffer(new char[maxsize_])
+  buffer(new char[maxsize])
 {
 }
 
 
-
-SocketBuffer::SocketBuffer(const SocketBuffer& rhs)
-    : LogLogUser ()
-{
-    copy(rhs);
-}
-
-
-
 SocketBuffer::~SocketBuffer()
 {
     delete [] buffer;
 }
 
 
-
-SocketBuffer&
-SocketBuffer::operator=(const SocketBuffer& rhs)
-{
-    if(&rhs != this) {
-        delete buffer;
-        copy(rhs);
-    }
-
-    return *this;
-}
-
-
-
-void
-SocketBuffer::copy(const SocketBuffer& r)
-{
-    SocketBuffer& rhs = OFconst_cast(SocketBuffer&, r);
-    maxsize = rhs.maxsize;
-    size = rhs.size;
-    pos = rhs.pos;
-    buffer = rhs.buffer;
-
-    rhs.maxsize = 0;
-    rhs.size = 0;
-    rhs.pos = 0;
-    rhs.buffer = 0;
-}
-
-
-
-
 //////////////////////////////////////////////////////////////////////////////
 // SocketBuffer methods
 //////////////////////////////////////////////////////////////////////////////
@@ -118,7 +73,7 @@ SocketBuffer::readByte()
         return 0;
     }
 
-    unsigned char ret = *(OFreinterpret_cast(unsigned char*, &buffer[pos]));
+    unsigned char ret = OFstatic_cast(unsigned char, buffer[pos]);
     pos += sizeof(unsigned char);
 
     return ret;
@@ -164,7 +119,7 @@ SocketBuffer::readInt()
     memcpy (&ret, buffer + pos, sizeof(ret));
     ret = ntohl(ret);
     pos += sizeof(unsigned int);
-
+    
     return ret;
 }
 
@@ -189,6 +144,7 @@ SocketBuffer::readString(unsigned char sizeOfChar)
         strlen = bufferLen / sizeOfChar;
     }
 
+#ifndef UNICODE
     if(sizeOfChar == 1) {
         tstring ret(&buffer[pos], strlen);
         pos += strlen;
@@ -206,6 +162,23 @@ SocketBuffer::readString(unsigned char sizeOfChar)
         getLogLog().error(DCMTK_LOG4CPLUS_TEXT("SocketBuffer::readString()- Invalid sizeOfChar!!!!"));
     }
 
+#else /* UNICODE */
+    if(sizeOfChar == 1) {
+        STD_NAMESPACE string ret(&buffer[pos], strlen);
+        pos += strlen;
+        return towstring(ret);
+    }
+    else if(sizeOfChar == 2) {
+        tstring ret;
+        for(tstring::size_type i=0; i<strlen; ++i) {
+            ret += OFstatic_cast(tchar, readShort());
+        }
+        return ret;
+    }
+    else {
+        getLogLog().error(DCMTK_LOG4CPLUS_TEXT("SocketBuffer::readString()- Invalid sizeOfChar!!!!"));
+    }
+#endif
 
     return tstring();
 }
@@ -220,7 +193,7 @@ SocketBuffer::appendByte(unsigned char val)
         return;
     }
 
-    *(OFreinterpret_cast(unsigned char*, &buffer[pos])) = val;
+    buffer[pos] = OFstatic_cast(char, val);
     pos += sizeof(unsigned char);
     size = pos;
 }
@@ -260,45 +233,28 @@ SocketBuffer::appendInt(unsigned int val)
 
 
 void
-SocketBuffer::appendSize_t(size_t val)
-{
-    if ((pos + sizeof(unsigned)) > maxsize)
-    {
-        getLogLog().error(DCMTK_LOG4CPLUS_TEXT("SocketBuffer::appendInt(size_t)- ")
-            DCMTK_LOG4CPLUS_TEXT("Attempt to write beyond end of buffer"));
-        return;
-    }
-    //if (val > (STD_NAMESPACE numeric_limits<unsigned>::max) ())
-    // htonl expects a 32 bit value
-    if (val > UINT_MAX)
-    {
-        getLogLog().error(DCMTK_LOG4CPLUS_TEXT("SocketBuffer::appendInt(size_t)-")
-            DCMTK_LOG4CPLUS_TEXT(" Attempt to write value greater than")
-            DCMTK_LOG4CPLUS_TEXT(" STD_NAMESPACE numeric_limits<unsigned>::max"));
-        return;
-    }
-
-    unsigned st = htonl(OFstatic_cast(unsigned, val));
-    memcpy(buffer + pos, &st, sizeof(st));
-    pos += sizeof(st);
-    size = pos;
-}
-
-
-void
 SocketBuffer::appendString(const tstring& str)
 {
-    size_t strlen = str.length();
+    size_t const strlen = str.length();
+    static size_t const sizeOfChar = sizeof (tchar) == 1 ? 1 : 2;
 
-    if((pos + sizeof(unsigned int) + strlen) > maxsize) {
-        getLogLog().error(DCMTK_LOG4CPLUS_TEXT("SocketBuffer::appendString()- Attempt to write beyond end of buffer"));
+    if((pos + sizeof(unsigned int) + strlen * sizeOfChar) > maxsize)
+    {
+        getLogLog().error(DCMTK_LOG4CPLUS_TEXT("SocketBuffer::appendString()-")
+            DCMTK_LOG4CPLUS_TEXT(" Attempt to write beyond end of buffer"));
         return;
     }
 
     appendInt(OFstatic_cast(unsigned, strlen));
+#ifndef UNICODE
     memcpy(&buffer[pos], str.data(), strlen);
     pos += strlen;
     size = pos;
+#else
+    for(tstring::size_type i=0; i<str.length(); ++i) {
+        appendShort(OFstatic_cast(unsigned short, str[i]));
+    }
+#endif
 }
 
 
@@ -317,4 +273,5 @@ SocketBuffer::appendBuffer(const SocketBuffer& buf)
 }
 
 
-
+} } // namespace log4cplus { namespace helpers {
+} // end namespace dcmtk
diff --git a/oflog/libsrc/socket.cc b/oflog/libsrc/socket.cc
index 5f201f8..14c15cc 100644
--- a/oflog/libsrc/socket.cc
+++ b/oflog/libsrc/socket.cc
@@ -4,7 +4,7 @@
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2003-2009 Tad E. Smith
+// Copyright 2003-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -18,32 +18,28 @@
 // See the License for the specific language governing permissions and
 // limitations under the License.
 
-#include "dcmtk/oflog/helpers/socket.h"
 #include "dcmtk/oflog/helpers/loglog.h"
+#include "dcmtk/oflog/internal/socket.h"
 
 
-using namespace dcmtk::log4cplus;
-using namespace dcmtk::log4cplus::helpers;
+namespace dcmtk {
+namespace log4cplus { namespace helpers {
 
-#if !defined(_WIN32)
-//#  include <unistd.h>
-#  define INCLUDE_UNISTD
-//#  include <errno.h>
-#  define INCLUDE_CERRNO
-#  include "dcmtk/ofstd/ofstdinc.h"
-#  define GET_LAST_ERROR errno
+
+extern DCMTK_LOG4CPLUS_EXPORT SOCKET_TYPE const INVALID_SOCKET_VALUE
+#if defined(_WIN32)
+    = OFstatic_cast(SOCKET_TYPE, INVALID_SOCKET);
 #else
-#  define GET_LAST_ERROR WSAGetLastError()
+    = OFstatic_cast(SOCKET_TYPE, -1);
 #endif
 
 
-
 //////////////////////////////////////////////////////////////////////////////
 // AbstractSocket ctors and dtor
 //////////////////////////////////////////////////////////////////////////////
 
 AbstractSocket::AbstractSocket()
-: sock(INVALID_SOCKET),
+: sock(INVALID_SOCKET_VALUE),
   state(not_opened),
   err(0)
 {
@@ -51,7 +47,8 @@ AbstractSocket::AbstractSocket()
 
 
 
-AbstractSocket::AbstractSocket(SOCKET_TYPE sock_, SocketState state_, int err_)
+AbstractSocket::AbstractSocket(SOCKET_TYPE sock_,
+    SocketState state_, int err_)
 : sock(sock_),
   state(state_),
   err(err_)
@@ -61,6 +58,9 @@ AbstractSocket::AbstractSocket(SOCKET_TYPE sock_, SocketState state_, int err_)
 
 
 AbstractSocket::AbstractSocket(const AbstractSocket& rhs)
+: sock(INVALID_SOCKET_VALUE),
+  state(not_opened),
+  err(0)
 {
     copy(rhs);
 }
@@ -80,9 +80,9 @@ AbstractSocket::~AbstractSocket()
 void
 AbstractSocket::close()
 {
-    if(sock != INVALID_SOCKET) {
+    if(sock != INVALID_SOCKET_VALUE) {
         closeSocket(sock);
-        sock = INVALID_SOCKET;
+        sock = INVALID_SOCKET_VALUE;
     }
 }
 
@@ -91,7 +91,7 @@ AbstractSocket::close()
 bool
 AbstractSocket::isOpen() const
 {
-    return sock != INVALID_SOCKET;
+    return sock != INVALID_SOCKET_VALUE;
 }
 
 
@@ -117,7 +117,7 @@ AbstractSocket::copy(const AbstractSocket& r)
     sock = rhs.sock;
     state = rhs.state;
     err = rhs.err;
-    rhs.sock = INVALID_SOCKET;
+    rhs.sock = INVALID_SOCKET_VALUE;
     rhs.state = not_opened;
     rhs.err = 0;
 }
@@ -129,34 +129,34 @@ AbstractSocket::copy(const AbstractSocket& r)
 //////////////////////////////////////////////////////////////////////////////
 
 Socket::Socket()
-: AbstractSocket()
+    : AbstractSocket()
+{ }
+
+
+Socket::Socket(const tstring& address, unsigned short port, bool udp /*= false*/)
+    : AbstractSocket()
 {
-}
+    sock = connectSocket(address, port, udp, state);
+    if (sock == INVALID_SOCKET_VALUE)
+        goto error;
 
+    if (! udp && setTCPNoDelay (sock, true) != 0)
+        goto error;
 
+    return;
 
-Socket::Socket(const tstring& address, int port)
-: AbstractSocket()
-{
-    sock = connectSocket(address, port, state);
-    if(sock == INVALID_SOCKET) {
-        err = errno;
-    }
+error:
+    err = get_last_socket_error ();
 }
 
 
 Socket::Socket(SOCKET_TYPE sock_, SocketState state_, int err_)
-: AbstractSocket(sock_, state_, err_)
-{
-}
-
+    : AbstractSocket(sock_, state_, err_)
+{ }
 
 
 Socket::~Socket()
-{
-}
-
-
+{ }
 
 
 
@@ -192,17 +192,29 @@ Socket::write(const SocketBuffer& buffer)
 }
 
 
+bool
+Socket::write(const STD_NAMESPACE string & buffer)
+{
+    long retval = helpers::write (sock, buffer);
+    if (retval <= 0)
+        close();
+
+    return retval > 0;
+}
+
+
+
 
 
 //////////////////////////////////////////////////////////////////////////////
 // ServerSocket ctor and dtor
 //////////////////////////////////////////////////////////////////////////////
 
-ServerSocket::ServerSocket(int port)
+ServerSocket::ServerSocket(unsigned short port)
 {
     sock = openSocket(port, state);
-    if(sock == INVALID_SOCKET) {
-        err = errno;
+    if(sock == INVALID_SOCKET_VALUE) {
+        err = get_last_socket_error ();
     }
 }
 
@@ -221,9 +233,11 @@ ServerSocket::~ServerSocket()
 Socket
 ServerSocket::accept()
 {
-    SocketState state_;
-    SOCKET_TYPE clientSock = acceptSocket(sock, state_);
-    return Socket(clientSock, state_, 0);
+    SocketState st = not_opened;
+    SOCKET_TYPE clientSock = acceptSocket(sock, st);
+    return Socket(clientSock, st, 0);
 }
 
 
+} } // namespace log4cplus { namespace helpers {
+} // end namespace dcmtk
